<template>
  <v-expansion-panel mandatory>
    <v-expansion-panel-header>
      {{ title }}
    </v-expansion-panel-header>

    <v-divider class="mb-2" />

    <v-expansion-panel-content class="pa-0 ma-0">
      <v-sheet
        v-if="loading"
        height="150px"
        class="d-flex justify-center align-center pa-0 ma-0"
      >
        <v-progress-circular
          :size="50"
          class="pa-0 ma-0"
          color="primary"
          indeterminate
        />
      </v-sheet>

      <template v-else>
        <v-sheet
          height="150px"
          class="overflow-auto pa-0 ma-0"
        >
          <slot v-if="hasDefaultSlot"></slot>

          <v-list
            v-else
            color="transparent"
            dense
            shaped
          >
            <v-list-item
              v-for="(item, index) in items"
              :key="index"
              link
              class="pa-0"
              @click="$emit('trigger', item)"
            >
              <v-list-item-content>
                <v-list-item-title>
                  {{ _get(item, itemText) }}
                </v-list-item-title>
              </v-list-item-content>

              <v-list-item-action v-if="itemCount">
                <small class="text--disabled">{{ _get(item, itemCount) }}</small>
              </v-list-item-action>
            </v-list-item>
          </v-list>
        </v-sheet>
      </template>
    </v-expansion-panel-content>
  </v-expansion-panel>
</template>

<script>
import _get from 'lodash/get'

export default {
  props: {
    title: {
      type: String,
      default: ''
    },

    items: {
      type: Array,
      default: () => ([])
    },

    loading: {
      type: Boolean,
      default: false
    },

    itemValue: {
      type: String,
      default: ''
    },

    itemText: {
      type: String,
      default: ''
    },

    itemCount: {
      type: String,
      default: ''
    }
  },

  computed: {
    hasDefaultSlot () {
      return !!this.$slots.default
    }
  },

  methods: {
    _get
  }
}
</script>
